program sorter;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var neu : array (.0..10000.) of record
                         name:string;
                         freq,
                         pol,
                         sat,
                         symbols,
                         vpid,
                         apid,
                         tpid,
                         caid,
                         sid,nid,tid,rid,
                         sort:string;
                         code:string;
                        end;
   xsort : array (.1..1000.) of string;

var f:textfile;
    i,j,p,
    n1,n2:integer;
    ok:boolean;
    x,
    z:string;
begin
 assignfile(f,'channels.conf.sort');
 reset(f);
 n2:=0;
 while not eof(f) do
  begin
   readln(f,z);
   p:=pos(':',z);
   if p>0
    then delete(z,p,length(z));
   inc(n2);
   xsort(.n2.):=z;
  end;
 closefile(f);
 assignfile(f,'channels.conf');
 reset(f);
 n1:=0;
 while not eof(f) do
  begin
   readln(f,z);
   if copy(z,1,1)=':' then continue;
   inc(n1);
   with neu[n1] do begin
   p:=pos(':',z);       name:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       freq:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       pol:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       sat:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       symbols:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       vpid:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       apid:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       tpid:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       caid:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       sid:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       nid:=copy(z,1,p-1);delete(z,1,p);
   p:=pos(':',z);       tid:=copy(z,1,p-1);delete(z,1,p);
   rid:=z;
   if ((apid='0') and (vpid='0')) or (copy(name,1,1)='[')
    then dec(n1)                // kein Bild, kein Ton
    else begin
          ok:=false;
          for i:=1 to n2 do
           begin
            ok:=name=xsort(.i.);
            if ok then break;
           end;
          if ok
           then begin
                 sort:=inttostr(i);
                 while length(sort)<5 do
                  sort:=' '+sort;
                 code:='Anfang';
                end
           else begin
                 sort:='';
                 code:='';
                 if vpid<>'0'
                  then begin
                        sort:=sort+'0';  // kein Radio
                        code:=code+'TV';
                       end
                  else begin
                        sort:=sort+'1';
                        code:=code+'Radio';
                       end;
                 if caid='0'
                  then begin
                        sort:=sort+'0';       // nicht verschlsselt
                        code:=code+' normal';
                       end
                  else begin
                        sort:=sort+'1';
                        code:=code+' crypt';
                       end;
                 if pos('deu',apid)>0
                  then begin
                        sort:=sort+'0';  // deutsch
                        code:=code+' deutsch';
                       end
                  else begin
                        sort:=sort+'1';
                        code:=code+' Ausland';
                       end;

                 sort:=sort+name;
                end;
         end;
   end;
  end;
 closefile(f);
 for i:=1 to n1-1 do
  for j:=i+1 to n1 do
   if neu[i].sort>neu[j].sort
    then begin
          neu[0]:=neu[i];
          neu[i]:=neu[j];
          neu[j]:=neu[0];
         end;
 assignfile(f,'channels.conf.neu');
 rewrite(f);
 x:='';
 for i:=1 to n1 do
  with neu(.i.) do
   begin
    if x<>code
     then begin
           writeln(f,':'+code);
           x:=code;
          end;
    writeln (f,name,':',freq,':',pol,':',sat,':',symbols,':',vpid,':',apid,':',tpid,':',caid,':',sid,':',nid,':',tid,':',rid);
   end;
 closefile(f);
end.
